import { SignerOptions } from "fast-jwt";
import { APIGatewayProxyStructuredResultV2 } from "aws-lambda";
export interface Session {
}
export declare type SessionValue = {
    [type in keyof Session]: {
        type: type;
        properties: Session[type];
    };
}[keyof Session];
export declare function useSession<T = SessionValue>(): T;
declare function create<T extends keyof Session>(input: {
    type: T;
    properties: Session[T];
    options?: Partial<SignerOptions>;
}): string;
export declare function cookie<T extends keyof Session>(input: {
    type: T;
    properties: Session[T];
    redirect: string;
    options?: Partial<SignerOptions>;
}): APIGatewayProxyStructuredResultV2;
export declare const Session: {
    create: typeof create;
    cookie: typeof cookie;
};
export {};
