import { Context } from "../context/context.js";
import { useHeader } from "../context/http.js";
import { createSigner, createVerifier } from "fast-jwt";
const KEY = "12345678";
const verifier = createVerifier({ key: KEY });
const SessionMemo = /* @__PURE__ */ Context.memo(() => {
    const header = useHeader("authorization");
    const token = header.substring(7);
    const jwt = verifier(token);
    return jwt;
});
// This is a crazy TS hack to prevent the types from being evaluated too soon
export function useSession() {
    const ctx = SessionMemo();
    return ctx;
}
function create(input) {
    const signer = createSigner(Object.assign(input.options || {}, { key: KEY }));
    const token = signer({
        type: input.type,
        properties: input.properties
    });
    return token;
}
export function cookie(input) {
    const token = create(input);
    return {
        statusCode: 307,
        headers: {
            location: input.redirect
        },
        cookies: [`auth-token=${token}; HttpOnly; Path=/; Expires=${new Date()}`]
    };
}
export const Session = {
    create,
    cookie
};
